require "spec_helper"

describe Generator do
  let(:script_name) { "my_script" }
  let(:generator) { Generator.new(script_name) }

  it "should generate correct result dirictories" do
    Dir.stub(:pwd) {"/home/user/my_scripts"}
    Generator.any_instance.stub(:template_directories) {[
      "/home/user/rsrc/lib/../template/lib",
      "/home/user/rsrc/lib/../template/spec"
    ]}

    exp = [
      ["/home/user/my_scripts/my_script/lib", "/home/user/rsrc/lib/../template/lib"],
      ["/home/user/my_scripts/my_script/spec", "/home/user/rsrc/lib/../template/spec"]
    ]

    generator.result_directories.sort.should eq exp.sort
  end

  it "should generate correct result files" do
    Dir.stub(:pwd) {"/home/user/my_scripts"}
    Generator.any_instance.stub(:template_files) {[
      "/home/user/rsrc/lib/../template/spec/my_script_spec.rb",
      "/home/user/rsrc/lib/../template/spec/spec_helper.rb",
      "/home/user/rsrc/lib/../template/Gemfile",
      "/home/user/rsrc/lib/../template/lib/my_script.rb",
      "/home/user/rsrc/lib/../template/Guardfile"
    ]}

    exp = [
      ["/home/user/my_scripts/my_script/spec/my_script_spec.rb", "/home/user/rsrc/lib/../template/spec/my_script_spec.rb"],
      ["/home/user/my_scripts/my_script/spec/spec_helper.rb", "/home/user/rsrc/lib/../template/spec/spec_helper.rb"],
      ["/home/user/my_scripts/my_script/Gemfile", "/home/user/rsrc/lib/../template/Gemfile"],
      ["/home/user/my_scripts/my_script/lib/my_script.rb", "/home/user/rsrc/lib/../template/lib/my_script.rb"],
      ["/home/user/my_scripts/my_script/Guardfile", "/home/user/rsrc/lib/../template/Guardfile"]
    ]

    generator.result_files.should eq exp
  end
end

